/*
 * Copyright 1998-2004 VIA Technologies, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * VIA, AND/OR ITS SUPPLIERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#include "padlock.h"
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

 
extern void aes_test();
extern void rng_test();
extern void sha256_test();
extern void sha1_test();
extern int phe_partial_available();
extern void sha1_partial_test();
extern void sha256_partial_test();
extern int sha_file_test();
extern int aes_performance_test();
extern int aes_file_test();
extern int pmm_test_speed();
extern int pmm_test_montmul_modexp();
extern int rsa_test();

void 
print_star()
{
    int i;

    printf("\n");
    for(i = 0;i < 50; i++)
    {
        printf("*");
    }
    printf("\n");

}
int main(void)
{
	int method;
	int phe_available = 0;
	int ace_available;
	int ace2_available;
	int rng_available = 0;
	int pmm_available = 0;

	phe_available = padlock_phe_available();
	ace_available = padlock_ace_available();
	ace2_available = padlock_ace2_available();
	rng_available = padlock_rng_available();
	pmm_available = padlock_pmm_available();
	
	do {
		printf("********************************************************************\n");
		printf("please choose the test you wanted:\n");
		printf("0 for exit, \n1 for aes performance test\n");
		printf("2 for aes file crypt (select to encrypt or decrypt),\n3 for aes APIs test.\n");
		printf("4 for sha1 test,\n5 for sha256 test.\n");
		printf("6 for sha file test,\n7 for rng test.\n");
		printf("8 for pmm montmul and modexp test\n");
		printf("9 for pmm speed test\n");
		printf("10 for rsa test\n");
		printf("11 for partial sha1 test\n");
		printf("12 for partial sha256 test\n");
		printf("********************************************************************\n");
		printf("input: ");
		scanf("%d", &method);
		printf("\n");
		if (method == 0)
			break;

		if (method == 1)
		{
			if (ace_available != 1)
			{
				printf("VIA hardware ACE is not available!\n");
				continue;
			}
			else if (ace2_available != 1)
			{
				printf("VIA hardware ACE2 is not available!\n");
			}
			printf("begin aes performance test:\n");
			aes_performance_test();
			continue;
		}
		if (method == 2)
		{
			if (ace_available != 1)
			{
				printf("VIA hardware ACE is not available!\n");
				continue;
			}
			else if (ace2_available != 1)
			{
				printf("VIA hardware ACE2 is not available!\n");
			}

			printf("begin aes file crypt test (only encrypt or decrypt):\n");
			aes_file_test();
			continue;

		}
		if (method == 3)
		{

			aes_test();
			continue;
		}
		if (method == 4)
		{
			if (phe_available != 1)
			{
				printf("VIA hardware PHE is not available! \n\n");
				continue;
			}
			printf("VIA hardware PHE is available! \n\n");

			sha1_test();
			continue;
		}
		if (method == 5)
		{
			if (phe_available != 1)
			{
				printf("VIA hardware PHE is not available! \n\n");
				continue;
			}
			printf("VIA hardware PHE is available! \n\n");

			sha256_test();
			continue;
		}
		if (method == 6)
		{
			if (phe_available !=1 )
			{
				printf("VIA hardware PHE is not available! \n\n");
				continue;
			}
			printf("VIA hardware PHE is available! \n\n");

			sha_file_test();
			continue;
		}
		if (method == 7)
		{
			if ( rng_available != 1 )
			{
				printf("VIA hardware RNG is not available!\n");
				continue;
			}
		
			rng_test();
			continue;
		}
		if (method == 8)
		{
			if (pmm_available != 1)
			{
				printf("VIA hardware PMM is not available!\n");
//				continue;
			}
			pmm_test_montmul_modexp();
			
			continue;
		}
		if (method == 9)
		{
			if (pmm_available != 1)
			{
				printf("VIA hardware PMM is not available!Software instead.\n");
//				continue;
			}
			pmm_test_speed();
			
			continue;
		}
		if (method == 10)
		{
			rsa_test();
			
			continue;
		}

		if (method == 11)
		{
			if (phe_partial_available() != 1)
			{
				printf("VIA hardware PHE's partial function is not available!\n");
				continue;
			}

			sha1_partial_test();
			
			continue;
		}

		if (method == 12)
		{
			if (phe_partial_available() != 1)
			{
				printf("VIA hardware PHE's partial function is not available!\n");
				continue;
			}

			sha256_partial_test();
			
			continue;
		}

		continue;

	}while (1);	

    return 1;
}

