BITS 32;

%macro cglobal 1

    %ifdef PREFIX
        global _%1
        %define %1 _%1
    %else
        global %1
    %endif

%endmacro


SECTION .text

;=================================================================
;   int __cdecl add32( int a, int b, int c, int d, int e )
;==================================================================

;global _add32
;_add32:
;    push   ebx
;    push   edi
;    push   esi
;    push   ebp
;begin
;	mov		eax,	[esp+20] 	;4+4*4
;	add		eax,	[esp+24]
;	add		eax,	[esp+28]
;	add		eax,	[esp+32]
;	add		eax,	[esp+36]
;end
;    pop	ebp
;    pop	esi
;    pop    edi 
;    pop    ebx
;    ret

;=================================================================
;   int asm_rng_available();
;==================================================================

cglobal asm_rng_available
asm_rng_available:
    push   ebx
    push   ebp
;begin
	mov		eax,  0xC0000000
	cpuid
    cmp		eax, 0xC0000001
	jb		rng_label
	mov		eax,  0xC0000001;
	cpuid
    and		edx, 0x0C;		RNG_MASK,CPUID EDX code for RNG
	cmp		edx, 0x0C;		RNG_MASK,CPUID EDX code for RNG
    jne		rng_label
    mov		eax, 1;
    jp		end_rng
rng_label:
	xor		eax, eax
end_rng:
    pop    ebp
    pop    ebx
    ret

;=================================================================
;   int asm_ace_available();
;==================================================================
cglobal asm_ace_available
asm_ace_available:
    push   ebx
    push   ebp
;begin
	mov		eax,  0xC0000000
	cpuid
    cmp		eax, 0xC0000001
	jb		ace_label
	mov		eax,  0xC0000001;
	cpuid
    and		edx, 0xC0;		ACE_MASK,CPUID EDX code for ACE
	cmp		edx, 0xC0;		ACE_MASK,CPUID EDX code for ACE
    jne		ace_label
    mov		eax, 1;
    jp		end_ace
ace_label:
	xor		eax, eax
end_ace:
    pop    ebp
    pop    ebx
    ret
    
;=================================================================
;   int asm_ace2_available();
;==================================================================

cglobal asm_ace2_available
asm_ace2_available:
    push   ebx
    push   ebp
;begin
	mov		eax,  0xC0000000
	cpuid
    cmp		eax, 0xC0000001
	jb		ace2_label
	mov		eax,  0xC0000001;
	cpuid
    and		edx, 0x300;		ACE2_MASK,CPUID EDX code for ACE2
	cmp		edx, 0x300;		ACE2_MASK,CPUID EDX code for ACE2
    jne		ace2_label
    mov		eax, 1;
    jp		end_ace2
ace2_label:
	xor		eax, eax
end_ace2:
    pop    ebp
    pop    ebx
    ret
    
;=================================================================
;   int asm_phe_available();
;==================================================================

cglobal asm_phe_available
asm_phe_available:
    push   ebx
    push   ebp
;begin
	mov		eax,  0xC0000000
	cpuid
    cmp		eax, 0xC0000001
	jb		phe_label
	mov		eax,  0xC0000001;
	cpuid
    and		edx, 0x0C00;		PHE_MASK,CPUID EDX code for PHE
	cmp		edx, 0x0C00;		PHE_MASK,CPUID EDX code for PHE
    jne		phe_label
    mov		eax, 1;
    jp		end_phe
phe_label:
	xor		eax, eax
end_phe:
    pop    ebp
    pop    ebx
    ret
    
;=================================================================
;   int asm_pmm_available();
;==================================================================

cglobal asm_pmm_available
asm_pmm_available:
    push   ebx
    push   ebp
;begin
	mov		eax,  0xC0000000
	cpuid
    cmp		eax, 0xC0000001
	jb		pmm_label
	mov		eax,  0xC0000001;
	cpuid
    and		edx, 0x3000;		PMM_MASK,CPUID EDX code for PMM
	cmp		edx, 0x3000;		PMM_MASK,CPUID EDX code for PMM
    jne		pmm_label
    mov		eax, 1;
    jp		end_pmm
pmm_label:
	xor		eax, eax
end_pmm:
    pop    ebp
    pop    ebx
    ret
    
    
;=================================================================
;   void asm_ace_ecb_op5(void *key, void *ctrl, void *src, void *dst, int count);
;==================================================================

cglobal asm_ace_ecb_op5
asm_ace_ecb_op5:
    push   ebx
    push   edi
    push   esi
    push   ebp
;begin
	pushfd
	popfd
	mov ecx, [esp+36]  ;count
	mov edx, [esp+24]  ;ctrl
	mov ebx, [esp+20]  ;key
	mov esi, [esp+28]  ;src
	mov edi, [esp+32]  ;dst
	DB	0xF3
	DB	0x0F
	DB	0xA7
	DB	0xC8
;end
    pop    ebp
    pop	   esi
    pop    edi 
    pop    ebx
    ret


;=================================================================
;   void asm_ace_cbc_op6(void *key, void *ctrl, void *src, void *dst, int count, void *iv);
;==================================================================
cglobal asm_ace_cbc_op6
asm_ace_cbc_op6:
    push   ebx
    push   edi
    push   esi
    push   ebp
;begin
	pushfd
	popfd
	mov ecx, [esp+36]  ;count
	mov edx, [esp+24]  ;ctrl
	mov ebx, [esp+20]  ;key
	mov eax, [esp+40]  ;iv 
	mov esi, [esp+28]  ;src
	mov edi, [esp+32]  ;dst
	DB	0xF3
	DB	0x0F
	DB	0xA7
	DB	0xD0
;end
    pop    ebp
    pop	   esi
    pop    edi 
    pop    ebx
    ret
;=================================================================
;   void asm_ace_cfb_op6(void *key, void *ctrl, void *src, void *dst, int count, void *iv);
;==================================================================
cglobal asm_ace_cfb_op6
asm_ace_cfb_op6:
    push   ebx
    push   edi
    push   esi
    push   ebp
;begin
	pushfd
	popfd
	mov ecx, [esp+36]  ;count
	mov edx, [esp+24]  ;ctrl
	mov ebx, [esp+20]  ;key
	mov eax, [esp+40]  ;iv 
	mov esi, [esp+28]  ;src
	mov edi, [esp+32]  ;dst
	DB	0xF3
	DB	0x0F
	DB	0xA7
	DB	0xE0
;end
    pop    ebp
    pop	   esi
    pop    edi 
    pop    ebx
    ret
;=================================================================
;   void asm_ace_ofb_op6(void *key, void *ctrl, void *src, void *dst, int count, void *iv);
;==================================================================
cglobal asm_ace_ofb_op6
asm_ace_ofb_op6:
    push   ebx
    push   edi
    push   esi
    push   ebp
;begin
	pushfd
	popfd
	mov ecx, [esp+36]  ;count
	mov edx, [esp+24]  ;ctrl
	mov ebx, [esp+20]  ;key
	mov eax, [esp+40]  ;iv 
	mov esi, [esp+28]  ;src
	mov edi, [esp+32]  ;dst
	DB	0xF3
	DB	0x0F
	DB	0xA7
	DB	0xE8
;end
    pop    ebp
    pop	   esi
    pop    edi 
    pop    ebx
    ret
;=================================================================
;   void asm_ace_ctr_op6(void *key, void *ctrl, void *src, void *dst, int count, void *iv);
;==================================================================
cglobal asm_ace_ctr_op6
asm_ace_ctr_op6:
    push   ebx
    push   edi
    push   esi
    push   ebp
;begin
	pushfd
	popfd
	mov ecx, [esp+36]  ;count
	mov edx, [esp+24]  ;ctrl
	mov ebx, [esp+20]  ;key
	mov eax, [esp+40]  ;iv 
	mov esi, [esp+28]  ;src
	mov edi, [esp+32]  ;dst
	DB	0xF3
	DB	0x0F
	DB	0xA7
	DB	0xD8
;end
    pop    ebp
    pop	   esi
    pop    edi 
    pop    ebx
    ret
;=================================================================
;   int asm_sha1_op3(void *src, void*dst, int nbytes);
;==================================================================
cglobal asm_sha1_op3
asm_sha1_op3:
    push   ebx
    push   edi
    push   esi
    push   ebp
;begin
	mov eax, 0x00000000;
	mov ecx,[esp+28]	;nbytes
	mov esi,[esp+20]	;src
	mov edi,[esp+24]	;dst
	DB	0xF3
	DB  0x0F
	DB  0xA6
	DB  0xC8
;end
    pop    ebp
    pop	   esi
    pop    edi 
    pop    ebx
    ret
;=================================================================
;   int asm_sha256_op3(void *src, void*dst, int nbytes);
;==================================================================
cglobal asm_sha256_op3
asm_sha256_op3:
    push   ebx
    push   edi
    push   esi
    push   ebp
;begin
	mov		eax, 0x00000000;
	mov		ecx,[esp+28]	;nbytes
	mov		esi,[esp+20]	;src
	mov		edi,[esp+24]	;dst
	DB	0xF3
	DB  0x0F
	DB  0xA6
	DB  0xD0
;end
    pop    ebp
    pop	   esi
    pop    edi 
    pop    ebx
    ret
    
;=================================================================
	;int asm_partial_sha1_op3(void *src, void*dst, int nblocks);
;=================================================================
cglobal asm_partial_sha1_op3
asm_partial_sha1_op3:
    push   ebx
    push   edi
    push   esi
    push   ebp
;begin
	mov eax, -1;		;initial to -1
	mov esi,[esp+20]     	;src
	mov edi,[esp+24]     	;dst
	mov ecx,[esp+28]      	;nblocks
	DB	0xF3
	DB  0x0F
	DB  0xA6
	DB  0xC8
;end
    pop    ebp
    pop	   esi
    pop    edi 
    pop    ebx
    ret

;=================================================================
	;int asm_partial_sha256_op3(void *src, void*dst, int nblocks);
;=================================================================
cglobal asm_partial_sha256_op3
asm_partial_sha256_op3:
    push   ebx
    push   edi
    push   esi
    push   ebp
;begin
	mov eax, -1		;initial to -1
	mov esi,[esp+20]     	;src
	mov edi,[esp+24]     	;dst
	mov ecx,[esp+28]      	;nblocks
	DB	0xF3
	DB  0x0F
	DB  0xA6
	DB  0xD0
;end
    pop    ebp
    pop	   esi
    pop    edi 
    pop    ebx
    ret

;=================================================================
;   void asm_pmm_op3(int temp, int dummy,void* mmCtx);
;==================================================================
cglobal asm_pmm_op3
asm_pmm_op3:
    push   ebx
    push   edi
    push   esi
    push   ebp
;begin
	mov		eax,[esp+24]	;DUMMY; 
	mov		ecx,[esp+20]	;TEMP;
	mov		esi,[esp+28]	;mmCONTEXT;
	DB	0xF3
	DB  0x0F
	DB  0xA6
	DB  0xC0
;end
    pop    ebp
    pop	   esi
    pop    edi 
    pop    ebx
    ret
    
;=================================================================
;   unsigned int asm_rng(unsigned char *rand);
;==================================================================

cglobal asm_rng
asm_rng:

    push   ebx
    push   edi
    push   esi
    push   ebp
;begin

	mov edi, [esp+20]	;rand;
	mov edx, 1;
	DB  0x0F
	DB  0xA7
	DB  0xC0
	and eax, 0x0000001F;

;end
    pop    ebp
    pop	   esi
    pop    edi 
    pop    ebx
    ret
;=================================================================
;   unsigned int bswap_32(unsigned int x)
;==================================================================
cglobal bswap_32
bswap_32:

	mov eax,  [esp+4];
	bswap   eax;
	ret
	
;=================================================================
;   int asm_is_nano();
;==================================================================
cglobal asm_is_nano
asm_is_nano:
	xor eax, eax				;get vendor ID
	cpuid	
	;cmp ebx, 0x746e6543		;means "tneC"
	;jne NO_VIA
	;cmp edx, 0x48727561		;means "Hrua"
	;jne NO_VIA
	;cmp ecx, 0x736c7561		;means "slna"
	;jne NO_VIA
	
	;verdor ID cannot got now, since our board has errata.
	mov		eax,  0xC0000000
	cpuid
    cmp		eax, 0xC0000001
	jb		NO_VIA
	mov		eax,  0xC0000001;
	cpuid
    and		edx, 0x0C00;		PHE_MASK,CPUID EDX code for PHE
	cmp		edx, 0x0C00;		PHE_MASK,CPUID EDX code for PHE
    jne		NO_VIA
	
	mov eax, 1				;get model
	cpuid
	or  eax, 0x000f
	cmp eax, 0x06ff			;3rd bit is F, then nano.
	jne NO_VIA
	
	mov eax, 1				;return 1
	ret
	
NO_VIA:
	xor eax,eax
	ret;