BITS 64

SECTION .text
;=================================================================
;   int asm_rng_available();
;==================================================================

global asm_rng_available
asm_rng_available:
    push   rbx
    push    rbp
    
    ;begin
	mov		eax,  0xC0000000
	cpuid
    cmp		eax, 0xC0000001
	jb		rng_label
	mov		eax,  0xC0000001;
	cpuid
    and		edx, 0x0C;		RNG_MASK,CPUID EDX code for RNG
	cmp		edx, 0x0C;		RNG_MASK,CPUID EDX code for RNG
    jne		rng_label
    mov		rax, 1;
    jp		end_rng
rng_label:
	xor		rax, rax
end_rng:
    pop     rbp
    pop     rbx
    ret
;=================================================================
;   int asm_ace_available();
;==================================================================
global asm_ace_available
asm_ace_available:
    push   rbx
    push    rbp
;begin
	mov		eax,  0xC0000000
	cpuid
    cmp		eax, 0xC0000001
	jb		ace_label
	mov		eax,  0xC0000001;
	cpuid
    and		edx, 0xC0;		ACE_MASK,CPUID EDX code for ACE
	cmp		edx, 0xC0;		ACE_MASK,CPUID EDX code for ACE
    jne		ace_label
    mov		rax, 1;
    jp		end_ace
ace_label:
	xor		rax, rax
end_ace:
    pop     rbp
    pop     rbx
    ret
     
;=================================================================
;   int asm_ace2_available();
;==================================================================

global asm_ace2_available
asm_ace2_available:
    push   rbx
    push    rbp
;begin
	mov		eax,  0xC0000000
	cpuid
    cmp		eax, 0xC0000001
	jb		ace2_label
	mov		eax,  0xC0000001;
	cpuid
    and		edx, 0x300;		ACE2_MASK,CPUID EDX code for ACE2
	cmp		edx, 0x300;		ACE2_MASK,CPUID EDX code for ACE2
    jne		ace2_label
    mov		rax, 1;
    jp		end_ace2
ace2_label:
	xor		rax, rax
end_ace2:
    pop     rbp
    pop     rbx
    ret
    
;=================================================================
;   int asm_phe_available();
;==================================================================

global asm_phe_available
asm_phe_available:
    push   rbx
    push    rbp
;begin
	mov		eax,  0xC0000000
	cpuid
    cmp		eax, 0xC0000001
	jb		phe_label
	mov		eax,  0xC0000001;
	cpuid
    and		edx, 0x0C00;		PHE_MASK,CPUID EDX code for PHE
	cmp		edx, 0x0C00;		PHE_MASK,CPUID EDX code for PHE
    jne		phe_label
    mov		rax, 1;
    jp		end_phe
phe_label:
	xor		rax, rax
end_phe:
    pop     rbp
    pop     rbx
    ret
 ;=================================================================
;   int asm_pmm_available();
;==================================================================

global asm_pmm_available
asm_pmm_available:
    push   rbx
    push    rbp
;begin
	mov		eax,  0xC0000000
	cpuid
    cmp		eax, 0xC0000001
	jb		pmm_label
	mov		eax,  0xC0000001;
	cpuid
    and		edx, 0x3000;		PMM_MASK,CPUID EDX code for PMM
	cmp		edx, 0x3000;		PMM_MASK,CPUID EDX code for PMM
    jne		pmm_label
    mov		rax, 1;
    jp		end_pmm
pmm_label:
	xor		rax, rax
end_pmm:
    pop     rbp
    pop     rbx
    ret
    
    
;=================================================================
;   void asm_ace_ecb_op5(void *key, void *ctrl, void *src, void *dst, int count);
;==================================================================

global asm_ace_ecb_op5
asm_ace_ecb_op5:
    push   rbx
    push    rbp
;begin
;	pushfd
;	popfd
    	mov rbx, rdi    ;key
	mov rdi, rcx     ;dst
	mov rcx, r8     ;count
	mov r10, rdx     ;src
	mov rdx, rsi      ;ctrl
    	mov rsi, r10
	DB	0xF3
	DB	0x0F
	DB	0xA7
	DB	0xC8
;end
    pop     rbp
    pop     rbx
    ret

;=================================================================
;   void asm_ace_cbc_op6(void *key, void *ctrl, void *src, void *dst, int count, void *iv);
;==================================================================
global asm_ace_cbc_op6
asm_ace_cbc_op6:
    push   rbx
    push    rbp
;begin
;	pushfd
;	popfd
    	mov rbx, rdi    ;key
	mov rdi, rcx     ;dst
	mov rcx, r8     ;count
	mov r10, rdx     ;src
	mov rdx, rsi      ;ctrl
    	mov rsi, r10
	mov rax, r9     ;iv 


	DB	0xF3
	DB	0x0F
	DB	0xA7
	DB	0xD0
;end
    pop     rbp
    pop     rbx
    ret
;=================================================================
;   void asm_ace_cfb_op6(void *key, void *ctrl, void *src, void *dst, int count, void *iv);
;==================================================================
global asm_ace_cfb_op6
asm_ace_cfb_op6:
    push   rbx
    push    rbp
;begin
;	pushfd
;	popfd
    	mov rbx, rdi    ;key
	mov rdi, rcx     ;dst
	mov rcx, r8     ;count
	mov r10, rdx     ;src
	mov rdx, rsi      ;ctrl
    	mov rsi, r10
	mov rax, r9     ;iv 
	DB	0xF3
	DB	0x0F
	DB	0xA7
	DB	0xE0
;end
    pop     rbp
    pop     rbx
    ret
;=================================================================
;   void asm_ace_ofb_op6(void *key, void *ctrl, void *src, void *dst, int count, void *iv);
;==================================================================
global asm_ace_ofb_op6
asm_ace_ofb_op6:
    push   rbx
    push    rbp
;begin
;	pushfd
;	popfd
    	mov rbx, rdi    ;key
	mov rdi, rcx     ;dst
	mov rcx, r8     ;count
	mov r10, rdx     ;src
	mov rdx, rsi      ;ctrl
    	mov rsi, r10
	mov rax, r9     ;iv 
	DB	0xF3
	DB	0x0F
	DB	0xA7
	DB	0xE8
;end
    pop     rbp
    pop     rbx
    ret
    
;=================================================================
;   void asm_ace_ctr_op6(void *key, void *ctrl, void *src, void *dst, int count, void *iv);
;==================================================================
global asm_ace_ctr_op6
asm_ace_ctr_op6:
    push   rbx
    push    rbp
;begin
;	pushfd
;	popfd
    	mov rbx, rdi    ;key
	mov rdi, rcx     ;dst
	mov rcx, r8     ;count
	mov r10, rdx     ;src
	mov rdx, rsi      ;ctrl
    	mov rsi, r10
	mov rax, r9     ;iv 
	DB	0xF3
	DB	0x0F
	DB	0xA7
	DB	0xD8
;end
    pop     rbp
    pop     rbx
    ret
;=================================================================
;   int asm_sha1_op3(void *src, void*dst, int nbytes);
;==================================================================
global asm_sha1_op3
asm_sha1_op3:
    push    rbx
    push    rbp
;begin
	xor rax, rax;		;initial to zero
	mov r10,rdi     	;src
	mov rdi,rsi     	;dst
    mov rsi,r10
	mov rcx,rdx      	;nbytes
	DB	0xF3
	DB  0x0F
	DB  0xA6
	DB  0xC8
;end
    pop     rbp
    pop     rbx
    ret
;=================================================================
;   int asm_sha256_op3(void *src, void*dst, int nbytes);
;==================================================================
global asm_sha256_op3
asm_sha256_op3:
    push    rbx
    push    rbp
;begin
	xor rax, rax;		;initial to zero
	mov r10,rdi     	;src
	mov rdi,rsi     	;dst
    	mov rsi,r10
	mov rcx,rdx      	;nbytes
	DB	0xF3
	DB  0x0F
	DB  0xA6
	DB  0xD0
;end
    pop     rbp
    pop     rbx
    ret

;=================================================================
	;int asm_partial_sha1_op3(void *src, void*dst, int nblocks);
;=================================================================
global asm_partial_sha1_op3
asm_partial_sha1_op3:
    push    rbx
    push    rbp
;begin
	mov rax, -1;		;initial to -1
	mov r10,rdi     	;src
	mov rdi,rsi     	;dst
    	mov rsi,r10
	mov rcx,rdx      	;nblocks
	DB	0xF3
	DB  0x0F
	DB  0xA6
	DB  0xC8
;end
    pop     rbp
    pop     rbx
    ret

;=================================================================
	;int asm_partial_sha256_op3(void *src, void*dst, int nblocks);
;=================================================================
global asm_partial_sha256_op3
asm_partial_sha256_op3:
    push    rbx
    push    rbp
;begin
	mov rax, -1		;initial to -1
	mov r10,rdi     	;src
	mov rdi,rsi     	;dst
    	mov rsi,r10
	mov rcx,rdx      	;nblocks
	DB	0xF3
	DB  0x0F
	DB  0xA6
	DB  0xD0
;end
    pop     rbp
    pop     rbx
    ret

;=================================================================
;   void asm_pmm_op3(int temp, int dummy,void* mmCtx);
;==================================================================
global asm_pmm_op3
asm_pmm_op3:
    push    rbx
    push    rbp
;begin
	mov		rax,rsi     	;DUMMY; 
	mov		rcx,rdi     	;TEMP;
	mov		rsi,rdx      	;mmCONTEXT;
	DB	0xF3
	DB  0x0F
	DB  0xA6
	DB  0xC0
;end
    pop     rbp
    pop     rbx
    ret
    
;=================================================================
;   unsigned int asm_rng(unsigned char *rand);
;==================================================================

global asm_rng
asm_rng:
    push    rbx
    push    rbp
;begin
;	mov rdi, rdi	;rand;
	mov edx, 2;

	DB  0x0F
	DB  0xA7
	DB  0xC0
	and rax, 0x1F;


;end
    pop     rbp
    pop     rbx
    ret
    
;=================================================================
;   unsigned int bswap_32(unsigned int x)
;==================================================================
global bswap_32
bswap_32:
	mov eax,  edi;
	bswap   eax;
	ret

;=================================================================
;   int asm_is_nano();
;==================================================================
global asm_is_nano
asm_is_nano:
	xor eax, eax				;get vendor ID
	cpuid	
	;cmp ebx, 0x746e6543		;means "tneC"
	;jne NO_VIA
	;cmp edx, 0x48727561		;means "Hrua"
	;jne NO_VIA
	;cmp ecx, 0x736c7561		;means "slna"
	;jne NO_VIA
	
	mov eax, 1				;get model
	cpuid
	or  eax, 0x000f
	cmp eax, 0x06ff			;3rd bit is F, then nano.
	jne NO_VIA
	
	mov eax, 1				;return 1
	ret
	
NO_VIA:
	xor eax,eax
	ret;	